import javax.swing.*;
import java.awt.*;


public class Street extends JPanel implements TrafficConstants{
    private int[] xPoly=new int[7];
	 private int[] yPoly=new int[7];
	 
		   
    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        g.setColor(Color.black);
        g.drawRect(10,10,1000,800);
        //180*140 for each block,
        //9 sites along horizontial,7 sites along vertical streets
        int blkWidth=180, blkHeight=140;
        int x=10, y=10;
        g.setColor(Color.gray);
        while (x<1010) {
           while (y<810) {
                g.fillRect(x,y,blkWidth,blkHeight);
                y += blkHeight + siteLength;
           }
           x += blkWidth + siteLength;
           y=10;
        } 
		  //draw arrows indicating the directions of links
		  g.setColor(Color.white);
		  for(int i=0;i<2;i++){
		  	int x0=210+200*(2*i+1)-48;
		  	for(int j=0;j<5;j++){
				int y0=10+j*160;
				defNArrow(x0,y0);
		  		g.fillPolygon(xPoly,yPoly,7);
			}
		  }

		  for(int i=0;i<3;i++){
		  	int x0=10+200*(2*i+1)-48;
			for(int j=0;j<5;j++){
				int y0=10+j*160;
				defSArrow(x0,y0);
				g.fillPolygon(xPoly,yPoly,7);
			}
		  }

		  for(int i=0;i<3;i++){
		  	int y0=10+160*(2*i+1)-48;
			for(int j=0;j<5;j++){
				int x0=10+200*j;
				defEArrow(x0,y0);
				g.fillPolygon(xPoly,yPoly,7);
			}
		  }

		  for(int i=0;i<2;i++){
		  	int y0=170+160*(2*i+1)-48;
			for(int j=0;j<5;j++){
				int x0=10+200*j;
				defWArrow(x0,y0);
				g.fillPolygon(xPoly,yPoly,7);
			}
		  }
    }
    
    public Dimension getPreferredSize()
    {
        return new Dimension( 1020,820 );
    }
 
    public Dimension getMinimumSize()
    {
        return getPreferredSize();
    }

	private void defNArrow(int x,int y)
	{
		xPoly[0]=x+14;
		xPoly[1]=x+20;
		xPoly[2]=x+17;
		xPoly[3]=x+17;
		xPoly[4]=x+12;
		xPoly[5]=x+12;
		xPoly[6]=x+8;

		yPoly[0]=y+8;
		yPoly[1]=y+22;
		yPoly[2]=y+22;
		yPoly[3]=y+32;
		yPoly[4]=y+32;
		yPoly[5]=y+22;
		yPoly[6]=y+22;
	}
	
	private void defSArrow(int x,int y)
	{
		xPoly[0]=x+14;
		xPoly[1]=x+20;
		xPoly[2]=x+17;
		xPoly[3]=x+17;
		xPoly[4]=x+12;
		xPoly[5]=x+12;
		xPoly[6]=x+8;

		yPoly[0]=y+32;
		yPoly[1]=y+18;
		yPoly[2]=y+18;
		yPoly[3]=y+8;
		yPoly[4]=y+8;
		yPoly[5]=y+18;
		yPoly[6]=y+18;
	}
  
   private void defEArrow(int x,int y)
	{
		xPoly[0]=x+32;
		xPoly[1]=x+18;
		xPoly[2]=x+18;
		xPoly[3]=x+8;
		xPoly[4]=x+8;
		xPoly[5]=x+18;
		xPoly[6]=x+18;

		yPoly[0]=y+14;
		yPoly[1]=y+20;
		yPoly[2]=y+17;
		yPoly[3]=y+17;
		yPoly[4]=y+12;
		yPoly[5]=y+12;
		yPoly[6]=y+8;
	}   

	private void defWArrow(int x,int y)
	{
		xPoly[0]=x+8;
		xPoly[1]=x+20;
		xPoly[2]=x+20;
		xPoly[3]=x+32;
		xPoly[4]=x+32;
		xPoly[5]=x+20;
		xPoly[6]=x+20;

		yPoly[0]=y+14;
		yPoly[1]=y+20;
		yPoly[2]=y+17;
		yPoly[3]=y+17;
		yPoly[4]=y+12;
		yPoly[5]=y+12;
		yPoly[6]=y+8;
	}   
}

